commit 504fbafd45a526f4851e7655d78d678d0c9eecbe
Author: Marek Polacek <polacek@redhat.com>
Date:   Mon Nov 25 09:45:13 2024 -0500

    c++: ICE with nested anonymous union [PR117153]
    
    In a template, for
    
      union {
        union {
          T d;
        };
      };
    
    build_anon_union_vars crates a malformed COMPONENT_REF: we have no
    DECL_NAME for the nested anon union so we create something like "object.".
    Most of the front end doesn't seem to care, but if such a tree gets to
    potential_constant_expression, it can cause a crash.
    
    We can use FIELD directly for the COMPONENT_REF's member.  tsubst_stmt
    should build up a proper one in:
    
        if (VAR_P (decl) && !DECL_NAME (decl)
            && ANON_AGGR_TYPE_P (TREE_TYPE (decl)))
          /* Anonymous aggregates are a special case.  */
          finish_anon_union (decl);
    
            PR c++/117153
    
    gcc/cp/ChangeLog:
    
            * decl2.cc (build_anon_union_vars): Use FIELD for the second operand
            of a COMPONENT_REF.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/other/anon-union6.C: New test.
            * g++.dg/other/anon-union7.C: New test.
    
    Reviewed-by: Jason Merrill <jason@redhat.com>
    (cherry picked from commit 10850f92b2a618ef1b1ad399530943ef4847823d)

diff --git a/gcc/cp/decl2.cc b/gcc/cp/decl2.cc
index f6c760338cc..139b5c15b3e 100644
--- a/gcc/cp/decl2.cc
+++ b/gcc/cp/decl2.cc
@@ -1951,7 +1951,7 @@ build_anon_union_vars (tree type, tree object)
 
       if (processing_template_decl)
 	ref = build_min_nt_loc (UNKNOWN_LOCATION, COMPONENT_REF, object,
-				DECL_NAME (field), NULL_TREE);
+				field, NULL_TREE);
       else
 	ref = build_class_member_access_expr (object, field, NULL_TREE,
 					      false, tf_warning_or_error);
diff --git a/gcc/testsuite/g++.dg/other/anon-union6.C b/gcc/testsuite/g++.dg/other/anon-union6.C
new file mode 100644
index 00000000000..d1cde30f790
--- /dev/null
+++ b/gcc/testsuite/g++.dg/other/anon-union6.C
@@ -0,0 +1,13 @@
+// PR c++/117153
+// { dg-do compile }
+
+template<typename T>
+void f() {
+  union {
+    union {
+      T d;
+    };
+  };
+  (void) (d + 0);
+}
+template void f<double>();
diff --git a/gcc/testsuite/g++.dg/other/anon-union7.C b/gcc/testsuite/g++.dg/other/anon-union7.C
new file mode 100644
index 00000000000..e89334a5d0e
--- /dev/null
+++ b/gcc/testsuite/g++.dg/other/anon-union7.C
@@ -0,0 +1,16 @@
+// PR c++/117153
+// { dg-do compile { target c++11 } }
+
+using U = union { union { int a; }; };
+
+U
+foo ()
+{
+  return {};
+}
+
+void
+g ()
+{
+  [[maybe_unused]] auto u = foo ();
+}

